// ********************  FILE:  olist.h  *************************
// 
// This file contains the declarations for the class OrderedList.
//
// Programmer:  J. Ingram
// Date:  January 22, 1997
// Updated:  May 27, 1997 to use the class simNode as list nodes
//
// Class OrderedList is a list of "events" maintained in increasing order
// by the time field of the events.  The nodes on the list are of type
// simNode (declared in the file snode.h).
//
// Needs file snode.h 
// *************************************************************** 
#ifndef ORDERLIST_DEF
#define ORDERLIST_DEF

#include "snode.h"

// ******************************************
// *******  OrderedList Declarations  *******
// ******************************************

class OrderedList
{
 public:
   OrderedList();                 // constructor for an empty list

   void insert(simNode *);        // inserts an event in the list in the
                                  // appropriate place based on its time

   simNode * getFirst();          // removes the first node from the list
                                  // (the one with the earliest time) and
                                  // returns a pointer to it

   void display ();               // displays the list

 private:
   simNode * First;               // pointer to the first element in the list
 };

#endif







